"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var shared_1 = require("./shared");
__export(require("./safeDecoders"));
__export(require("./shared"));
__export(require("./unsafeDecoders"));
function decodeString(decoder, input) {
    var decode = function (input) {
        var json;
        try {
            json = JSON.parse(input);
        }
        catch (_a) {
            throw new shared_1.ParseError(input);
        }
        return decoder(json);
    };
    if (typeof input !== "undefined") {
        return decode(input);
    }
    return decode;
}
exports.decodeString = decodeString;
function decodeValue(decoder, input) {
    if (arguments.length === 2) {
        return decoder(input);
    }
    return decoder;
}
exports.decodeValue = decodeValue;
